parameters sDbfName, sNtxName

/* List the names of any user-defined or extend functions used in your
   index keys and remove the comment "//" */
// external

local nResult, nBadRecno
local aResults := { 'Key mismatch', 'Record number out of range' }
local aErrors := { 'Unable to open specified index', ;
                   'Unable to read from specified index', ;
                   'Unable to find specified database', ;
                   'Index key is undefined on the specified database' }

* begin
    if ( (sDbfName == NIL) .or. (sNtxName == NIL) )
        ? 'Invalid parameters.  The proper syntax is:'
        ? 'VTNX <database name> <index name>'
        errorlevel(2)
        return
    end
    nResult := corrupted(sDbfName, sNtxName, @nBadRecno)
    if ( nResult > 0 )
        ? aResults[nResult]
        ? 'Offending record number: ' + ltrim(str(nBadRecno))
        errorlevel(1)
    elseif ( nResult < 0 )
        ? aErrors[-nResult]
        errorlevel(2)
    else
        ? 'No problems found'
    end
return
